
// rev  13 mars2025
// rev 22-09-2024    460800 bds
// rev 26-08-2023    230400 bds
#include "UART1_Functions.h"

void UART1_Init(void)
{
    U1P1L = 0x00;
    U1P1H = 0x00;
    U1P2L = 0x00;
    U1P2H = 0x00;
    U1P3L = 0x00;
    U1P3H = 0x00;
    U1CON0 = 0xB0; // BRGS high speed; MODE Asynchronous 8-bit mode; RXEN enabled; TXEN enabled; ABDEN disabled; 
    // RXBIMD Set RXBKIF on rising RX input; BRKOVR disabled; 
    // WUE disabled; SENDB disabled; ON enabled; 
    U1CON1 = 0x80;    
    // TXPOL not inverted; FLO off; C0EN Checksum Mode 0; RXPOL not inverted;
    //RUNOVF RX input shifter stops all activity; STP Transmit 1Stop bit, receiver verifies first Stop bit; 
    U1CON2 = 0x00;
    U1BRGL = 0x8A; 
    //   U1BRGL = 0x8A; // BRGL 138;  115200 bds
    //   U1BRGL = 0x45; // BRGL  69;  230400 bds test OK
    //   U1BRGL = 0x22; // BRGL  34;  460800 bds test OK
    U1BRGH = 0x00; // BRGH 0; 
    U1FIFO = 0x00; // STPMD in middle of first Stop bit; TXWRE No error; 
    // ABDIF Auto-baud not enabled or not complete; 
    // WUIF WUE not enabled by software; ABDIE disabled; 
    U1UIR = 0x00;
    // ABDOVF Not overflowed; TXCIF 0; RXBKIF No Break detected; 
    // RXFOIF not overflowed; CERIF No Checksum error; 
    U1ERRIR = 0x00;
    // TXCIE disabled; FERIE disabled; TXMTIE disabled; ABDOVE disabled;
    // CERIE disabled; RXFOIE disabled; PERIE disabled; RXBKIE disabled; 
    U1ERRIE = 0x00;
    U1CON0bits.TXEN=1;
    U1CON0bits.RXEN=1;  // enable reception
    PIE3bits.U1RXIE = 0;  // disable receive interrupt
}


//void strConstRamCpy(unsigned char   *dest, const  unsigned char *source)
void strConstRamCpy( char   *dest, const  char *source)
 { static unsigned char cc=0;
  
 cc= *(source);
  while ( cc>0 )
  { cc=*(source);
   *(dest++) =cc;
   source++ ;
  }
  *(dest) = 0 ;    // terminateur
}




//void PrintChar(unsigned char txData)
void PrintChar(char txData)
{
    while(0 == PIR3bits.U1TXIF)
    {
        __asm("NOP");
    }
    U1TXB = txData;    // Write the data byte to the USART.
}

 //void Print (unsigned char *Tc)
  void Print (char *Tc)
 {  int k;
   k=0;      
   while(*(Tc+k)>0) 
   {
     while(PIR3bits.U1TXIF==0);
     U1TXB=*(Tc+k);
    k++;
    if(k>128)break;
   }
}

 // void CPrint (const unsigned char *T1)
 void CPrint (const  char *T1)
 { 
   while(*(T1)>0) 
   {
     while(PIR3bits.U1TXIF==0);
     U1TXB=*(T1);
    T1++;
   }
}


void CRLF1(void)
{
   while(PIR3bits.U1TXIF==0);
   U1TXB=13;
    while(PIR3bits.U1TXIF==0);
   U1TXB=10;  
  }   


void RAZ_UART1_Buffer1(void)
{ int i1;   
      if (PIR3bits.U1RXIF==1)   c1=U1RXB ;
      for (i1=0;i1<sizeof(Buffer1)-1;i1++) Buffer1[i1]=0;
   
      U1CON0bits.U1RXEN=1;
      U1ERRIR = 0x00;
      U1ERRIE = 0x00;
      Buffer1[0]=0;
      i1=0;
      Index1=0;
      c1=0;
      Flag_Buffer1 =0 ;
      PIE3bits.U1IE  = 1;       // int uart1 enabled
      PIE3bits.U1RXIE =1;  
} 

void Decompile_byte(unsigned char un)
{
 unsigned char masque;
 masque = 0x80;
 while (masque > 0u )
 {
   if ((un & masque)>0)
      PrintChar('*');  //   UART1_Write(49u);  //  '1'
    else
       PrintChar(' ');  // UART1_Write(48u);  //  '0'
    masque =masque >>1;
  }
}


void Decompile_byte_(unsigned char un,char modalite)
{
 unsigned char masque;
 masque = 0x80;
 while (masque > 0u )
 {
   if ((un & masque)>0)
   {  
     if (modalite==1)  PrintChar('*'); else PrintChar(49);  //  '1'
   }  
    else
    {     
      if (modalite==1) PrintChar('.');else  PrintChar(48);  //  '0'
    }  
    masque =masque >>1;
  }
}
