/*
    Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.8
    Device            :  PIC18F27K42
    Driver Version    :  2.00
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 

*/
#include "mcc_generated_files/mcc.h"
#include "ctype.h"
#include <limits.h>
#include <string.h>

#define VERSION "250413"
#define MCU " 18F27K42"
#define POWER_SUPPLY " 5V "
#define DIR " C:\\MPLABX_PrOJECTS"
#define COMPILO "XC8 V2.36 C99"
#define PACK "PIC18F-K_DFP 1.6.125"

#ifndef _XTAL_FREQ
#define _XTAL_FREQ 64000000 
#endif

#define Directory "C:\\MPLABX_Projects\\18F27K42_PMW_CCP1234_2025"
#define Project  "18F27K42_PMW_CCP1234_2025"
#define Source   " main.c , rev :"
#define Annexe   " XC8 V2.36 C99  Pack: PIC18F-K_DFP 1.6.125"
#define Others   " LCD_4bits_I2C_2024-01, UART1_Functions.h , mcc.h," 
#define Add_Inc  " Dialogue_Operateur_PC_via_UART_2023-0905\r\n"
#define Eeprom   " Eeprom...........   "
#define Hardware " BASE 18F27K42 + I2C1 LCD4x20 + INA226 + UART1 115200 + module IBT 2 Mosfet I2C1" 
#define Config   " Internal Fosc 64MHz"
#define Schema   " Carte_Portail_2_Vantaux_24v_H-en-MOSFET_INA226-HIP4082_FQP30N06L_V5.0.3.pdf by H.T.\r\n"

#define With_SQA_Analyser
#ifdef With_SQA_Analyser
#define SQA_Dir TRISCbits.TRISC5
#define SQA LATCbits.LATC5
#endif

#define IBT2_Enable_Dir TRISAbits.TRISA3
#define IBT2_Enable LATAbits.LATA3

#define CR 13
#define LF 10
#define TAB 9

#define With Led_Rouge   // utilise la sortie STOP
#ifdef With Led_Rouge
#define With Led_Rouge
#define Led_Rouge   LATAbits.LATA4
#define Led_Rouge_Dir   TRISAbits.TRISA4
#endif

#define  Alert_PIN_Dir  TRISCbits.TRISC0
#define  Alert_PIN PORTCbits.RC0;



#include "i2c1_master.h"
#include "i2c1_master_example.h"
#include "UART1_Functions.h"

#define With_LCD  
#ifdef With_LCD   // I2C !
#define LCD_ADDR 0x27  //PCF8574 inclus sur gros LCD 4x20 Bleu Paul sur Prtototype Breaboard
#include "LCD_4bits_I2C_2024-01.h"
#endif

#define With_INA226


const  char Msg0[]=" BASE 18F27K42 + LCD4X20+ PWM1,2,3,4 Analog RA0,1,2,3\r\n";
const  char Msg1[]=" Directory :"Directory"\r\n";
const  char Msg2[]=" Project : "Project"\r\n";
const  char Msg3[]=" Source : "Source"_"VERSION"\r\n";
const  char Msg4[]=" Config "Config"\r\n";
const  char Msg5[]=" Autres :\r\n "Others"\r\n";
const  char Msg6[]=" A inclure: \r\n"Add_Inc"\r\n";
const  char Msg7[]=" LCD_chars_Speciaux_2024.h,   Eeprom :"Eeprom"\r\n";
const  char Msg8[]=" Hardware :"Hardware"\r\n Schema:"Schema"\r\n";
const  char Msg9[]=" RA0=...RA1=Analog ,RA4=led,RA3...RC6=TX UART1 RC7=RX UART\r\n";
const  char MsgA[]=" RB0 ALERT input\r\n";
const  char MsgB[]=" LCD 4x20 bus I2C1 HW : RC3=SCL,RC4=SDA\r\n";
const  char * Messages[]={Msg0,Msg1,Msg2,Msg3,Msg4,Msg5,Msg6,Msg7,Msg8,Msg9,MsgA,MsgB};
const  char Blancs[]="  ";

#define UART1_RX_BUFFER_SIZE 128 
  
// variables Globales usuelles 
unsigned int  i,j,k,l,m,n;
unsigned char  c1,c2,c3,cx,cc;
unsigned int Nb_Boucles=0;
volatile unsigned char Buffer1[UART1_RX_BUFFER_SIZE];
volatile unsigned int Index1,i1;
volatile unsigned char Flag_Buffer1=0;
char TEXTE [128];
char * txt;
bool Status_GIE_Bit;  
// pointeurs 
unsigned char * p0;
unsigned char * p1;
unsigned char * px;
char CRam1[128];
unsigned char Tampon[32];
float F0,F1,F2,F3,F4;
unsigned int k1_PWM,k2_PWM;

volatile uint16_t Cpt0, Cpt1, Cpt3, Cpt6;    
volatile uint8_t Flag_Timer0=0;
volatile uint8_t Flag_Timer1=0;
volatile uint8_t Flag_Timer6=0;
volatile uint8_t Flag_Eeprom=0; 
int Etat;
bool Status_GIE_Bit;
char Dummy;

//unsigned long SMT1_Measure;
//unsigned  char *ST;
unsigned long  L1=0;
unsigned long  L2=0;
unsigned long  L3=0;
//  I2C  LCD ,MCP
volatile unsigned char Addr;
unsigned char I2_Adresses_Devices[8];
unsigned char tmp[10]={0,0,0,0,0,0,0,0,0,0};


volatile struct Anybits {   // 8 flags
       unsigned  Tmr0_Elapsed:1;     // for timer0 16bits
       unsigned  Tmr1_Elapsed:1;     // for timer1 16bits
       unsigned  Tmr2_Elapsed:1;     // for timer2 8bits
       unsigned  Tmr3_Elapsed:1;     // for timer3 16bits
       unsigned  Tmr4_Elapsed:1;     // for timer4 8bits
       unsigned  Tmr6_Elapsed:1;     // for timer6 8bits
       unsigned  NCO_initialise:1;   // for NCO
       unsigned  Key_ON :1;          // detection appui BP
 }Drapeaux ;
 
int Duty_Value=0;
int Duree_Boucle=0;

char LCD_char12=' ';  // caractere variable en position 12 affichage repos LCD
char LCD_char15=' ';  // caractere variable en position 15 Affichage repos  LCD


#ifdef With_INA226
#define INA226_ADDR 0x40  // sur 7 bits


 // Conversion time in microseconds
#define      CONV_TIME_140    0
#define      CONV_TIME_204    1
#define      CONV_TIME_332    2
#define      CONV_TIME_588    3
#define      CONV_TIME_1100   4
#define      CONV_TIME_2116   5
#define      CONV_TIME_4156   6
#define      CONV_TIME_8244   7

// INA226_measureMode;
#define    INA226_POWER_DOWN  0x00
#define    INA226_TRIGGERED   0x03
#define    INA226_CONTINUOUS  0x077

// INA226_ALERT_TYPE
#define      SHUNT_OVER     0x8000
#define      SHUNT_UNDER    0x4000
#define      BUS_OVER       0x2000
#define      BUS_UNDER      0x1000
#define      POWER_OVER     0x0800
#define      CURRENT_OVER   0xFFFE
#define      CURRENT_UNDER  0xFFFF


 #define INA226_CONF_REG        0x00 //Configuration Register
 #define INA226_SHUNT_REG        0x01 //Shunt Voltage Register
 #define INA226_BUS_REG          0x02 //Bus Voltage Register
 #define INA226_PWR_REG          0x03 //Power Register 
 #define INA226_CURRENT_REG      0x04 //Current flowing through Shunt
 #define INA226_CAL_REG          0x05 //Calibration Register 
 #define INA226_MASK_EN_REG      0x06 //Mask/Enable Register 
 #define INA226_ALERT_LIMIT_REG  0x07 //Alert Limit Register
 #define INA226_MAN_ID_REG       0xFE //Contains Unique Manbufacturer Identification Number
 #define INA226_ID_REG           0xFF //Contains unique ID

        /* parameters, flag bits */
 uint16_t INA226_RST        =0x8000; //Reset 
 uint16_t INA226_AFF        =0x0010; //Alert function flag
 uint16_t INA226_CVRF       =0x0008; //Conversion ready flag
 uint16_t INA226_OVF        =0x0004; //Overflow flags AFF
 uint16_t INA226_ALERT_POL  =0x0002; //Alert pin polarity - if set then active-high
        //Latch enable - if set then alert flag remains until mask/enable register is read
        //if not set then flag is cleared after next conversion within limits
 uint16_t INA226_LATCH_EN   =0x0001; 


//--- INA226-----
  int16_t mvA=0;   
  uint16_t mvU=0; // toujours positif
  float Power=0.0;
  int16_t mA=0;
  float Amps=0.00;
  float Volts=0.00;
  float Seuil_Alerte=0.0;
  
  uint8_t AFF_Flag=0;
  uint16_t ALERTE_STATUS=0;
  
  void   INA226_Init_Config(void);
#endif


//void  MAJ_RTC_Manuelle(void);
//unsigned char Dec2Bcd(uint8_t n);    
//unsigned char Bcd2Dec( uint8_t  val);

void Vectored_Interrupts_Init(void);
//void Hardware_Init();

//void TMR6_Init_500ms(char N);
//void SMT1_Init(char Choix_SMT1_Clock); // clock 64MHz,16Mhz,500Khz,31,25Khz
//void Init_I2C (void);
void I2C1_Write1ByteRegister(i2c1_address_t address, unsigned char reg, unsigned char data);
void I2C_PCF8574_Write(unsigned char  Addr , unsigned char value);

void  Vectored_Interrupts_Init(void)
{  //rev 25-10-2023
    INTCON0bits.GIE=0;
    INTCON0bits.IPEN = 1;
    INTCON0bits.GIEH = 0; // dis high priority interrupts
    INTCON0bits.GIEL = 0; // dis low priority interrupts*
     
    INTCON0bits.IPEN = 1; // Enable interrupt priority
   //  __asm("BCF INTCON0,GIE");
   // GIE = 0;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x00; // unlock IVT
    IVTBASEU = 0;
    IVTBASEH = 0;
    IVTBASEL = 8;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0x01; // lock IVT
    // Assign peripheral interrupt priority vectors
    IPR3bits.U1RXIP = 1;
    IPR1bits.INT0IP = 1;
    IPR4bits.TMR1IP = 0;
    IPR3bits.TMR0IP = 0;
    IPR4bits.TMR2IP = 0;  // low priority
 //   IPR7bits.TMR4IP = 0;
//    IPR9bits.TMR6IP = 0;
    IPR0bits.IOCIP =  0;
  
    INTCON0bits.GIEL = 0; // disable low priority interrupts
    INTCON0bits.GIEH = 0; // disable high priority interrupts
    INTCON0bits.GIE=0;

}

void __interrupt(irq(IRQ_IOC),high_priority) IOC_ISR(void)
{ 
 if (IOCIF) 
 {
    unsigned char i;
    char  p = IOCCF;
    //delay_ms(500);
    for (i=0; i<8; i++) 
    {
      while (!U1TXIF) { }
      U1TXB = p&0x80 ? '1' : '.';
      p <<= 1 ;
    }
    IOCCF = 0x00;
    IOCIF=0; 
 }
}

/*
void __interrupt(irq(IRQ_INT0),high_priority) INT0_ISR(void)
{  
   if( (INT0IE) && (INT0IF))
   {    
      Drapeaux.Key_ON=0;
          U1TXB='#';
         AFF_Flag=1;
       // __delay_ms(80);  
   }
  PIR0bits.IOCIF=0;
  IOCBF=0;
  INT0IF=0;   
}
  */

void __interrupt(irq(IRQ_U1RX),high_priority) UART1_rx_vect_isr(void)
{
   static char cx;
  //  U1TXB='H';  // pour debugging only
  if ( (PIR3bits.U1RXIF==1) && (PIE3bits.U1RXIE ==1) )
  {   
      c1=U1RXB;  // => RAZ PIR3bits.U1RXIF
   //   U1TXB='*'; // echo
     if ( (c1==13) || (i1>UART1_RX_BUFFER_SIZE-1))
     { 
      Flag_Buffer1=1;
      Buffer1[i1]=0;
      Index1=i1;
      i1=0; 
     PIE3bits.U1RXIE =0;
     }
     else
     {
       Buffer1[i1]=c1;
       i1++;
       Index1=i1;
      } 
   } 
  // INTCON0bits.GIEL=0;
}

void __interrupt(irq(IRQ_TMR6),low_priority) TMR6_ISR(void)
{  
    //  if (Cpt6>0)  // decomptage maxi 32767
    //   {
    //     Cpt6--;
   //     }
   //   else
   //   {
       Cpt6++;
        Drapeaux.Tmr6_Elapsed=1;
   //     TMR6IE=0;
   //   } 
     Flag_Timer6=1;
     TMR6IF=0;// clear the TMR6 interrupt flag

 }


void TMR6_Init_500ms(char N)
{   
    //  cycle=500 mS modifi -> 1sec !
     PIE9bits.TMR6IE=0 ;
     // T2PSYNC Not Synchronized; T2MODE Software control; T2CKPOL Rising Edge; T2CKSYNC Not Synchronized; 
    T6CLKCON = 0x05;    // T2CS FOSC/4 ou    0x05 pour 500Khz
    T6HLT = 0x00;
    T6TMR = 0x00;  // TMR4 0; 
    T6CON = 0x70 | 0x07 ; // Prescaler =7=> 1/128 Poscaler=7=>  1/8 =>  ticks= 512  S
    T6PR=244;   // 512 * (244+1) * 128 * 8 => 501760S ->  500mS sec
   Flag_Timer6=0;
   Drapeaux.Tmr6_Elapsed=0;
 //  if(N>0) 
 //  { 
 //    Cpt6=N;
//   }
//   else
//   {
 //    Cpt6=1;      
 //  }
  Cpt6=0; 
 PIE9bits.TMR6IE=1 ;  // TMR6IE_bit=1;
 TMR6IF=0;   
 TMR6ON = 1;
 }

void __delay_xSec( uint8_t N)
{
static uint8_t i2;  
for (i2 =0;i2<N;i2++)
{
    __delay_ms(1000);
}
}

void I2C_PCF8574_Write(unsigned char Adrp,unsigned char value)
{//rev 14-10-2023 
 char tmpx[2];
 tmpx[0]=value;
 tmpx[1]=0;
 I2C1_WriteNBytes(Adrp, tmpx, 1); 
  __delay_us(30);
} 


void Init_I2C (void)
{   
    I2C1CLK    = 0x03;      // I2C1 Clock Selection Register, MFINTOSC 500kHz ?? 100kHz ??  // doc p. 581
  // 2-04-2023  probleme maxi pCF SLC =100KHz
  //  I2C1CLK    = 0x06;    ///0110	 TMR2 post scaled output	42Khz theorique
  // SQA mesure  18.00+11.76=29.76S -> 33.6Khz ?? why ?
    I2C1CON0   = 0x04;      // I2C1 Control Register 0, Master mode, 7-bit Address  // doc p.577
    I2C1CON1   = 0x80;      // I2C1 Control Register 1, Acknowledge value transmitted after received data 
                            //(when I2CCNT=0) : 1 = NACK     (Not ACKnowledge)  // doc p.579
    I2C1CON2   = 0x00;      // I2C1 Control Register 2, envoi Start non auto, SDAHT 300ns hold time, BFRET 8 i2c clock pulses  // doc p.580
    I2C1CNT = 0;
 //   I2C1CON2bits.FME=1;
    I2C1CON2bits.ABD=0; //  ADB=0; // Transmitted Address data is loaded from the I2CxADB0/1 registers.
     // I2C1ADB1   = 0x3C;      //0x3C adresse bus I2C mini oled SSD1306
    I2C1ADB1   = 0x20 ;   //LCD_ADDR;   // LCD 2x16 avec PCF8754
    I2C1PIRbits.PCIF = 0;  // clear STOP bit flag
  //  I2C1CON2bits.ABD=1;   
    I2C1CON0bits.EN=0;   // i2c1 OFF   
}

 bool I2C1_DevicePresent(int16_t Address)
{
I2C1PIRbits.PCIF = 0;                // clear STOP bit flag
I2C1ADB1 = Address;                  // load slave Addr and R/W
I2C1CNT = 0;
I2C1CON0bits.S = 1;                  // send START + Addr
while (I2C1PIRbits.PCIF == 0);       // wait for STOP
return !I2C1CON1bits.ACKSTAT;
}

 
void Test_Presence_I2C_devices()
{
 int i,j;
 txt=&TEXTE[0]; 
 *(txt)=0;
 //I2C1CON2 = 0x00;  // <- OK
I2C1CON2bits.ABD=0; //  ADB=0; // Transmitted Address data is loaded from the I2CxADB0/1 registers.
I2C1CON0bits.EN = 1;
for (i=2; i<252; i=i+2)
{
if (I2C1_DevicePresent(i))
{
k=i>>1;
sprintf(txt," @ decimal #%4u  soit @Device 7bits = 0X%02X ",i,k);
//Print(txt);
switch (k)
{
case 0x20:// de base + 7 autres
case 0x21:
case 0x22:
case 0x23:
    //...etc 
case 0x27:
   strcat(txt," PCF8754 for LCD 2x16cars"); 
   break;
case 0x28:
case 0x29:
case 0x2A:
// case etc ..
strConstRamCpy(CRam1,"PCF8574 8bits IO" );  
  j=strlen(txt);
  strcpy(txt+j,CRam1);
  break;
case 0x37:
   strcat(txt,"LCD 2119 2x16cars"); // de base + 7 autres
   break;
case 0x38:
case 0x39:
case 0x3A:
case 0x3B:
  // case etc ..
  strcat(txt,"PCF8574A 8bits I/O"); // de base + 7 autres
  break;
case 0x3C:
strcat(txt,"OLED SSD1306");
break;
case 0x40:
   strcat(txt,"INA226 Current sensor");
   break;
case 0x57:
strcat(txt,"EEPROM 512bytes");
break;
case 0x68:
strcat(txt,"RTC DS3231");
break;
case 0xA0:
strcat(txt,"Eeprom 24LCxxx 256k ou 512K");
break;
default:
strcat(txt,"non connu !");
break;
}
Print(txt);CRLF1();
}
}
I2C1CON0bits.EN = 0;
//I2C1CON2 = 0x18;
I2C1CON2bits.ABD=1;
CRLF1();
I2C1CON0bits.EN = 1;
}


  
void Waiting_Enter_Key_Pressed(void)
{
      CPrint(" Pres Enter key !\r\n");
    //PIR3bits.U1RXIF=0;
     c1=U1RXB;
    while(PIR3bits.U1RXIF==0)
    { PrintChar('.');
     __delay_ms(100);
    }
     //PIR3bits.U1RXIF=0;
    c1=U1RXB;
    // PIR3bits.U1RXIF=0;   
}

void Hardware_Init()
{
    
    /**
    LATx registers
    */
    LATA = 0x00;
    LATB = 0x00;
    LATC = 0x00;

    /**
    TRISx registers
    */
    TRISA = 0xEF;
    TRISB = 0x9E;
    TRISC = 0x81;

    /**
    ANSELx registers
    */
    ANSELC = 0x66;
    ANSELB = 0x61;
    ANSELA = 0x00;

    /**
    WPUx registers
    */
    WPUE = 0x00;
    WPUB = 0x00;
    WPUA = 0x00;
    WPUC = 0x00;

#ifdef With_SQA_Analyser
    SQA_Dir=0; //output RC5
    SQA=0; //LATC5
#endif   
    
    IBT2_Enable_Dir=0 ; //RA3
    IBT2_Enable=0; 
    
#ifdef With Led_Rouge
    ANSELAbits.ANSELA4=0;
    TRISAbits.TRISA4 = 0;
    Led_Rouge_Dir=0; //RA4 en sortie
    Led_Rouge=0; //RA4
    
    Alert_PIN_Dir=1; // RC0
    IOCAP=0;
    IOCAN=0;
    IOCAF=0;
    IOCCP=0;
    IOCCN=0x01;
    IOCCF=0;
#endif 
    /*
    RxyI2C registers
    */
    RB1I2C = 0x00;
    RB2I2C = 0x00;
    RC3I2C = 0x00;
    RC4I2C = 0x00;

    /*
    ODx registers
    */
    ODCONA = 0x00;
    ODCONB = 0x00;
    ODCONC = 0x18;
    /*
    SLRCONx registers
    */
    SLRCONA = 0xFF;
    SLRCONB = 0xFF;
    SLRCONC = 0xFF;
    /**
    INLVLx registers
    */
    INLVLA = 0xFF;
    INLVLB = 0xFF;
    INLVLC = 0xFF;
    INLVLE = 0x08;

     RC2PPS = 0x09;   //RC2->CCP1:CCP1;   
     RC1PPS = 0x0A;   //RC1->CCP2:CCP2; 
     RB5PPS = 0x0B;   //RB5->CCP3:CCP3; 
     RB0PPS = 0x0C;   //RB0->CCP4:CCP4;    
	
    I2C1SDAPPS = 0x14;   //RC4->I2C1:SDA1;    
    RC3PPS = 0x21;   //RC3->I2C1:SCL1;    
    RC4PPS = 0x22;   //RC4->I2C1:SDA1;    
    
    RC6PPS = 0x13;   //RC6->UART1:TX1;    
    U1RXPPS = 0x17;   //RC7->UART1:RX1;    
    I2C1SCLPPS = 0x13;   //RC3->I2C1:SCL1;    

}

#ifdef With_INA226
void INA226_Init_Config(void)
{   
    CPrint(" Config  INA226_CONF_REG,0x43FF (was 0x4127 )\r\n");
    p1=&tmp[0];
    //  Addr=0x40; // INA226_ADDR   0x40 8 bits; 
    // configuration RST  AVGX VBUSCTX VSHCTX   MODEx   // 16-bits
    // AVG2 AVG1 AVG0  bit 9  11
    // 0 => 1    1 => 4   2-> 8  3-> 16   4 -> 128 ...... 7 -> 1024
    //Reset 1  dumy 000  NbAverage 011= 3 => 64mS 
    // conversion Time Vbus 100=1,1mS  conversion Time SHuntV 100=1,1mS
    // mode 111 Shunt & bus continuous
    // 0b 0 000 001     Vbus 011   Vsht 111    mode 111; 
    // 0b 0100  0011 0011 1111; 
    // V.O. INA226_Write_16bits_Register(INA226_CONF_REG,0x4127);
      tmp[0]=INA226_CONF_REG;
      tmp[1]=0x47;  // 64 ms average Vbus 1.1mS  VSh 1.1mS
      tmp[2]=0x3F; // shunt convertion time 8.24mS  mode continu
      Addr=INA226_ADDR;
     // I2C1CON2bits.ABD=1;
      cx=3;
      I2C1_WriteNBytes(Addr, p1, cx); 
     //   CPrint(" Calibration register 05h <- 0x0034 (shunt 0,1 ohm) \r\n");
      CPrint(" Calibration register 05h (pour shunt 0,01 ohm  et 8 Amps) \r\n");
      // 0x00D1B
      tmp[0]=INA226_CAL_REG;  //5120 =>0x1400
      tmp[1]=0x00;   // 0x00;// pour shunt 0,1
      tmp[2]=0x14;    // 0x34;//pour shunt 0,1
      Addr=INA226_ADDR;
      p1=&tmp[0];
      cx=3;
      I2C1_WriteNBytes(Addr, p1,cx);
     //  Mask / Enale Register   
     //  SOL/SUL shunt voltage over/Under Limit Alert
     //  BOL /BUL  Bus Voltage Over/Under Limit Alert
     //  POL :Power Over limit Alert           
     //  CNVR Convertion Readdy Alert   
      // 0b 1 0 0 0 0 0 0 0
      // shunt Over alert
      // // 0b 0 0 0 AFF CVRF OVF APOL LEN 
      // AFF Alarm Fonction Flag aune limite a t franchie !
      // CVRF conversion Ready Flag mesure OK   OVF : Overflow Flag  debordement d'un registre
      // APOL= Alert polarity=active high with APOL=0 
      // LEN=1 =Alarme Latche enable
        CPrint(" Mask/Alert  MASK_EN_REG register 06h <- 0x8001\r\n");
        // 0x00D1B
        tmp[0]=INA226_MASK_EN_REG;
        tmp[1]=0x80;
        tmp[2]=0x01;  // avec latch_EN=1
        Addr=INA226_ADDR;
        p1=&tmp[0];
        cx=3;
        I2C1_WriteNBytes(Addr, p1, cx);
           
     //    CPrint(" Alert MASK_EN_REG register 07h <- 24000 pour 6 A\r\n");
    //    tmp[0]=INA226_ALERT_LIMIT_REG;
    //    // 24000 pour 6Amps
    //    tmp[1]=0x5D;
    //    tmp[2]=0xC0;
        
        CPrint(" Alert MASK_EN_REG register 07h <- 2400 pour 0.6 A\r\n");
        tmp[0]=INA226_ALERT_LIMIT_REG;
        // 2400 pour 0.6Amps
        tmp[1]=0x09;
        tmp[2]=0x60;
        Addr=INA226_ADDR;
        p1=&tmp[0];
        cx=3;
        I2C1_WriteNBytes(Addr, p1, cx);
            
        Addr= INA226_ADDR;
        tmp[0]=0;
        tmp[1]=0;
        p1=&tmp[0];
        I2C1_ReadDataBlock(Addr,INA226_CURRENT_REG, p1,3);
        k=(tmp[0]<<8) + tmp[1];
         sprintf(CRam1," Mesure de courant % 5d mA \r\n",k);
        Print(CRam1);
     
        Addr= INA226_ADDR;
        tmp[0]=0;
        tmp[1]=0;
        p1=&tmp[0];
        I2C1_ReadDataBlock(Addr,INA226_ALERT_LIMIT_REG, p1,3);
        k=(tmp[0]<<8) + tmp[1];
        Seuil_Alerte= 8.192 * (float)k / 32768;
        sprintf(CRam1," Seuil d'alerte %3.3f Amperes\r\n",Seuil_Alerte);
        Print(CRam1);
      
        
        Addr= INA226_ADDR;
        tmp[0]=0;
        tmp[1]=0;
         tmp[2]=0;
        p1=&tmp[0];
        I2C1_ReadDataBlock(Addr,INA226_MAN_ID_REG, p1,3);  // 2260
        k=(tmp[0]<<8) + tmp[1];
        sprintf(CRam1," INA Manufactuer  0x%04X\r\n",k);
        Print(CRam1);
        
        Addr= INA226_ADDR;
        tmp[0]=0;
        tmp[1]=0;
         tmp[2]=0;
        p1=&tmp[0];
        I2C1_ReadDataBlock(Addr,INA226_ID_REG, p1,3);  // 2260
        k=(tmp[0]<<8) + tmp[1];
        sprintf(CRam1," INA Identifiant 0x%04X\r\n",k);
        Print(CRam1);
   
        CPrint(" Fin de parametrage INA226... OK\r\n\r\n");
  }


int Lecture_INA_mA()
{ 
     Addr= INA226_ADDR;
    tmp[0]=0;
    tmp[1]=0;
    p1=&tmp[0];  
    I2C1_ReadDataBlock(Addr,INA226_CURRENT_REG,p1,3);
    mA=(tmp[0]<<8) + tmp[1];
    return(mA);
}


void Mesures_INA226(void)
{

    Addr= INA226_ADDR;
    tmp[0]=0;
    tmp[1]=0;
    p1=&tmp[0];
    I2C1_ReadDataBlock(Addr,INA226_BUS_REG, p1,3);
    mvU=(tmp[0]<<8) + tmp[1];
         
    Addr= INA226_ADDR;
    tmp[0]=0;
    tmp[1]=0;
    p1=&tmp[0];  
    I2C1_ReadDataBlock(Addr,INA226_SHUNT_REG,p1,3);
    mvA=(tmp[0]<<8) + tmp[1];
    
        Addr= INA226_ADDR;
        tmp[0]=0;
        tmp[1]=0;
        p1=&tmp[0];
        I2C1_ReadDataBlock(Addr,INA226_ALERT_LIMIT_REG, p1,3);
        k=(tmp[0]<<8) + tmp[1];
        Seuil_Alerte= 8.192 * (float)k / 32768;
   //     sprintf(CRam1," Seuil d'alerte %3.3f Amperes\r\n",Seuil_Alerte);
   //     Print(CRam1);
 
    Addr=INA226_ADDR; 
    tmp[0]=0; tmp[1]=0;
    p1=&tmp[0]; // pointeur sur debut de table
    I2C1_ReadDataBlock(Addr,INA226_MASK_EN_REG,p1,2);
    ALERTE_STATUS= (tmp[0]<<8) + tmp[1];
    AFF_Flag=(ALERTE_STATUS & 0x00F0)>>4;
    
     if(AFF_Flag==1)   Led_Rouge=0;  // allume led
    
      Addr= INA226_ADDR;
      tmp[0]=0;
      tmp[1]=0;
      p1=&tmp[0];
      I2C1_ReadDataBlock(Addr,INA226_CURRENT_REG, p1,3);
      mA=(tmp[0]<<8) + tmp[1];
     //   sprintf(CRam1," Mesure de courant % 5d mA \r\n",mA);
     //   Print(CRam1);
             
    Addr= INA226_ADDR;
    tmp[0]=0;
    tmp[1]=0;
    p1=&tmp[0];
    I2C1_ReadDataBlock(Addr,INA226_PWR_REG, p1,3);
    k=(tmp[0]<<8) + tmp[1];
    Power= (float)k / 2500.0;

}

#endif

void main(void)
{
       
    SYSTEM_Initialize();
   
    Flag_Eeprom=0;
    for (i=0;i<sizeof(TEXTE);i++) TEXTE[i]=0;
    for (i=0;i<sizeof(Buffer1);i++) Buffer1[i]=0;
    for (i=0;i<sizeof(CRam1)-1;i++) CRam1[i]=0;
    for (i=0;i<9;i++) tmp[i]=0;
    txt=&TEXTE[0];   
    Vectored_Interrupts_Init();
    Hardware_Init();
    
     #ifdef With Led_Rouge
    i=0;
    do
    {
      Led_Rouge=1;
       __delay_ms(200);
        Led_Rouge=0;
       __delay_ms(200);
      //      __asm("btg LATA,4") ;
         i++;  
    }
    while(i<8);
    Led_Rouge=1; // eteinte
   #endif
       
    UART1_Init();
    __delay_ms(100);
    CRLF1();
     CRLF1();
    CPrint(" Presentation :\r\n");       
    for (i=0;i<9;i++)   
    {
       CPrint(Messages[i]);
    }
    CRLF1();
    sprintf(txt," Compiled %s at %s UTC  version XC8 :%d \r\n", __DATE__, __TIME__,__XC8_VERSION);
    Print(txt);
    CRLF1();
    __delay_xSec(2);
    
#ifdef With_LCD    
    CPrint(" version Prototype : LCD Bleu a l'adresse 0x27 !\r\n");
     CPrint(" Init_I2C() 100Khz;\r\n");
    Init_I2C(); //SCLK=  500Khz / 5 = 100Khz
    CPrint(" Test presence devices sur Bus I2C1\r\n");
    Test_Presence_I2C_devices();
    CRLF1();
    
    Addr=LCD_ADDR; 
    NbCarPL=20; // LCD 4x20 !
    sprintf(CRam1," adresse LCD= %d soit 0X%02X \r\n",Addr,Addr);
    Print(CRam1);
    I2C1CON2bits.ABD=1;
    
    CPrint(" \r\nSequence d'Init LCD 4x20 via I2C1 PCF8574\r\n");
    I2C1CON0bits.EN=1;   
    LCD_init(); 
    CRLF1();
    LCD_Cmd(LCD_CLEAR);// 0x01
 
    LCD_Write_CText_At(1,1,"Version Prototype !");
     __delay_xSec(2); 
    LCD_Cmd(LCD_CLEAR);// 0x01
    LCD_Cmd(LCD_HOME); //  0x02
     __delay_ms(100); 
    CPrint(" Chargement caracteres Speciaux  en CGRAM\r\n");
    LCD_putsRom("Caracteres Speciaux ");
    LCD_Load_Custom_Chars(0);  // parametre:  0=mode silence,  1=bavard
    for (i=0;i<8;i++) 
    {
     //  CPrint(Special_Name1[i]); CRLF1();
       LCD_Chr_At(2,i+1,i);  
    }
     __delay_xSec(1);  
     
#endif
     
    CPrint(" Initialisation PWM1,2 avec FReq 3,9KHz (Timer2)\r\n");
    PWM1_Initialize();
     PWM2_Initialize();
   //   PWM3_Initialize();
   //    PWM4_Initialize();
     CRLF1();  

     // armement capture reception UART
     RAZ_UART1_Buffer1();
     INTCON0bits.GIE=1;
     INTCON0bits.GIEH=1;
     
  #ifdef With_LCD     

    CPrint(" * PWM1 sur RC2 (TMR2)=0% \r\n");
    CPrint(" * PWM2 sur RC1 (TMR2)=0% \r\n");
 //   CPrint(" * PWM3 sur RB0 (TMR4)=0% \r\n");
 //   CPrint(" * PWM4 sur RB5 (TMR4)=0% \r\n"); 
     
    LCD_Cmd(LCD_CLEAR);// 0x01
    LCD_Cmd(LCD_HOME); //  0x02
    k=1;     F1=(float)k1_PWM/10.2; PWM1_LoadDutyValue(k1_PWM);
    sprintf(CRam1,"PWM1-RC2  %4d %3.1f%c",k1_PWM,F1,'%');
    LCD_Write_Text_At(1,1,CRam1);
    k=2;     F2=(float)k2_PWM/10.2; PWM1_LoadDutyValue(k2_PWM);
    sprintf(CRam1,"PWM2-RC1  %4d %3.1f%c",k2_PWM,F2,'%');
    LCD_Write_Text_At(2,1,CRam1);                
 //   k=600;     F3=(float)k/10.2; PWM1_LoadDutyValue(k);
 //   sprintf(CRam1,"PWM3-RB5 %4d %3.1f%c",k,F3,'%');
 //   LCD_Write_Text_At(3,1,CRam1);                
 //    k=800;     F4=(float)k/10.2; PWM1_LoadDutyValue(k);
  //  sprintf(CRam1,"PWM4-RB0 %4d %3.1f%c",k,F4,'%');
 //   LCD_Write_Text_At(4,1,CRam1);  
    __delay_xSec(3); 
    LCD_Cmd(LCD_CLEAR);// 0x01
    LCD_Cmd(LCD_HOME); //  0x02
    
    CPrint(" Init INA226 mesure de courant via I2C, shunt de 150mV pou 15Amps\r\n");
    INA226_Init_Config();
    
    
    TEXTE[0]=0;
    txt=&TEXTE[0];
    
    IOCCN=0x01; // RC0  falling edge interrupt  
    PIR0bits.IOCIF=0;
    IOCEN=1;
    IOCCF=0;
    IOCCP=0x01;
    PIE0bits.IOCIE=0;// dvalide toutes interrup IOC
    //INT0IF=0;
    //INT0IE=1;
    ALERTE_STATUS=0;
    AFF_Flag=0;    
#endif
    CPrint(" Test differentes valeurs de Duty-cycle via le clavier terminal YAT \r\n"); 
    CPrint(" Activer la sortie PWMy avec MA=1    (arret via MA=0)\r\n");
    CPrint(" Entrer une valeur PWMy=xxxx puis <enter> avec y=1 ou 2 au clavier\r\n");
    do
   {
        TEXTE[0]=0;
        txt=&TEXTE[0];
        RAZ_UART1_Buffer1(); // et arme interrupt UART RX
     // delay d' attente saisie au clavier
      __delay_ms(1500);    //  
      if(Flag_Buffer1==1)
       {
            CPrint("Recu :");
            Print(Buffer1);
            CRLF1();
            p0=&Buffer1[0];
           
            if ( (*(p0)=='H') && (*(p0+1)=='e') && ( *(p0+2)=='l') && ( *(p0+3)=='p') )
            { 
                CPrint("Help\r\n");
                CPrint(" MA=1 ou 0   1=Marche ou 0=Arret PWM \r\n");
                CPrint(" PWM1=XXXX   avec XXX de 0000 a1000 pour RC2 de 0% a100% \r\n");
                CPrint(" PWM2=XXXX   avec XXX de 0000 a1000 pour RC1 de 0% a100% \r\n");
     //           CPrint(" PWM3=XXXX   avec XXX de 0000  1000 pour RB5 de 0%  100% \r\n");
    //            CPrint(" PWM4=XXXX   avec XXX de 0000  1000 pour RB0 de 0%  100% \r\n");
            p0=0;
            }   
            if( (*(p0)=='R') & (*(p0+1)=='e') &  (*(p0+5)=='r') & ( *(p0+6)=='t') )
            {
               AFF_Flag=0; 
               IBT2_Enable=1;
               CPrint("\r\n RAZ alarme ,Restart\r\n");
                Led_Rouge=1; //eteinte
               p0=0;
             }  
                 
 	        if ( (*(p0)=='P') && (*(p0+1)=='W') && ( *(p0+2)=='M') && ( *(p0+4)=='=') )
            { 
                cx=*(p0+3);
                m=0;
                if(  (isdigit(cx) & (cx>48) & (cx< 51))  ) // 1  2 seulement
                {  
                 m++;
                if (isdigit(*(p0+5))) { k=  (*(p0+5)-48)*1000; m++; }
                if (isdigit(*(p0+6))) { k=k+(*(p0+6)-48)*100; m++; }
                if (isdigit(*(p0+7))) { k=k+(*(p0+7)-48)*10; m++; }
                if (isdigit(*(p0+8))) { k=k+(*(p0+8)-48)*1; m++; }
                if ( (m==5) && (k<1016))
                {   
                   #ifdef With_SQA_Analyser 
                    SQA=1;
                    #endif
                     switch (cx)
                     {
                        case '1':
                            CPrint(" Saisie OK "); 
                            k1_PWM=k;
                            F1=(float)k/10.2;
                            #ifdef With_LCD   
                            sprintf(CRam1,"PWM1-RC2 %4d %3.1f%c",k1_PWM,F1,'%');
                            LCD_Write_Text_At(1,1,CRam1);
                            #else
                            sprintf(CRam1," Saisie OK  PWM (CCP1 output RC2 ) = %5d soit %3.2f%c\r\n",k,F1,'%');
                            #endif
                            PWM1_LoadDutyValue(k1_PWM);
                            break;
                        case '2':
                            k2_PWM=k;
                            F2=(float)k/10.2;
                            #ifdef With_LCD   
                            sprintf(CRam1,"PMW2-RC1 %4d %3.1f%c",k2_PWM,F2,'%');
                            LCD_Write_Text_At(2,1,CRam1);
                            #else
                            sprintf(CRam1," Saisie OK  PWM (CCP2 output RC1 ) = %5d soit %3.2f%c\r\n",k,F2,'%');
                            #endif
                            PWM2_LoadDutyValue(k2_PWM);
                            break;
                   /*
                    *      case '3':
                            F3=(float)k/10.2;  
                            #ifdef With_LCD  
                            sprintf(CRam1,"PWM3-RB5 %4d %3.1f%c",k,F3,'%'); 
                            LCD_Write_Text_At(3,1,CRam1);
                             #else
                            sprintf(CRam1," Saisie OK  PWM (CCP3 output RB5 ) = %5d soit %3.2f%c\r\n",k,F3,'%');
                            #endif
                            PWM3_LoadDutyValue(k);
                            break;
                        case '4':
                            F4=(float)k/10.2;
                            #ifdef With_LCD   
                            sprintf(CRam1,"PWM4-RB0 %4d %3.1f%c",k,F4,'%');
                           LCD_Write_Text_At(4,1,CRam1);
                            #else
                              sprintf(CRam1," Saisie OK  PWM (CCP4 output RB0 ) = %5d soit %3.2f%c\r\n",k,F4,'%');
                            #endif
                            PWM4_LoadDutyValue(k);
                            break;
                    * */
                        default :
                           cx=0; 
                           CPrint(" Erreur cx\r\n");
                           break;
                     }
                    if(cx>0)
                     { Print(CRam1);CRLF1();
                     __delay_ms(10);
                     }  
                    #ifdef With_SQA_Analyser 
                    SQA=0;
                    #endif  
                }
                else
                {
                     sprintf(CRam1," Erreur de Saisie  choix CCP %c valeur PWM %5d\r\n",cx,k);
                     Print(CRam1);
                   //  CPrint(" Rappel : cde PMWy=XXXX avec y=choix PMW 1 a 4 et  xxxx  valeur duty 0000 a 1015\r\n" );
                      CPrint(" Rappel : cde PMWy=XXXX avec y=choix PMW 1 ou 2 et  xxxx  valeur duty 0000 a 1015\r\n" );
                }
              }
             p0=0;   
            }
            if ( (*(p0)=='M') && (*(p0+1)=='A') && ( *(p0+2)=='=') )
            { 
               cx=*(p0+3);
               if (cx=='1')
               {

                  IBT2_Enable=1;  // RA3
                  CPrint(" ITB2 Enabled \r\n" );
          
               }   
               else
               {
                  CPrint(" ITB2 Disabled \r\n" );
                  IBT2_Enable=0; 
               }      
             p0=0;   
            }    
          //  CRLF1();  
          Flag_Buffer1=0;
       }
       else
       {

        CRam1[0]=0;
        sprintf(CRam1,"Nb=%5d  PWM1= % 4d",Nb_Boucles,k1_PWM);
        LCD_Write_Text_At(1,1,CRam1);
        Print(CRam1);
        sprintf(CRam1,"        PWM2= % 4d",k2_PWM);
        LCD_Write_Text_At(2,1,CRam1);
        Print(CRam1);
                       
#ifdef With_INA226
        Mesures_INA226();
        Addr=LCD_ADDR; 
      //  sprintf(CRam1," mvA=% 5d mvU=% 5d ",mvA,mvU);
      //  LCD_Write_Text_At(2,1,CRam1);
      //  strcat(txt,CRam1);
      //  Print(CRam1);
        Volts = mvU * 1.25 / 1000;
        Amps = mvA * 2.5/10000.0;  // (5120/2048=2.5)
        sprintf(CRam1," %2.2f V  %2.3f A  .",Volts,Amps);
        if (AFF_Flag==1) 
        {
        *(CRam1+19)='O';
          IBT2_Enable=0;  
          k1_PWM=0;k2_PWM=0;
          PWM1_LoadDutyValue(0);
          PWM2_LoadDutyValue(0);
          CPrint("\r\n Alarm Over_current ..faire un reset\r\n");
        }
        Print(CRam1);
        LCD_Write_Text_At(3,1,CRam1); 
        Power=Volts*Amps;
        sprintf(CRam1," %3.3f W  Seuil=%3.3f  ",Power,Seuil_Alerte);
        Print(CRam1); 
        LCD_Write_Text_At(4,1,CRam1); 
        CRam1[0]=0;
        CRLF1();
        Nb_Boucles ++; 
#endif
       }
        SQA=1;
        __delay_ms(100);
        SQA=0;
     
  } 
  while (1);
  
}
/*
 End of File
 * 
 * 
 * 
 * 
 * 
  Presentation :
 BASE 18F27K42 + LCD4X20+ PWM1,2,3,4 Analog RA0,1,2,3
 Directory :C:\MPLABX_Projects\18F27K42_PMW_CCP1234_2025
 Project : 18F27K42_PMW_CCP1234_2025
 Source :  main.c , rev :_250413
 Config  Internal Fosc 64MHz
 Autres :
  LCD_4bits_I2C_2024-01, UART1_Functions.h , mcc.h,
 A inclure: 
 Dialogue_Operateur_PC_via_UART_2023-0905

 LCD_chars_Speciaux_2024.h,   Eeprom : Eeprom...........   
 Hardware : BASE 18F27K42 + I2C1 LCD4x20 + INA226 + UART1 115200 + module IBT 2 Mosfet I2C1
 Schema: Carte_Portail_2_Vantaux_24v_H-en-MOSFET_INA226-HIP4082_FQP30N06L_V5.0.3.pdf by H.T.


 Compiled Apr 13 2025 at 15:38:34 UTC  version XC8 :2360 

 version Prototype : LCD Bleu a l'adresse 0x27 !
 Init_I2C() 100Khz;
 Test presence devices sur Bus I2C1
 @ decimal #  78  soit @Device 7bits = 0X27  PCF8754 for LCD 2x16cars
 @ decimal # 128  soit @Device 7bits = 0X40 INA226 Current sensor


 adresse LCD= 39 soit 0X27 
 
Sequence d'Init LCD 4x20 via I2C1 PCF8574
 .123456789A
 Chargement caracteres Speciaux  en CGRAM
 Initialisation PWM1,2 avec FReq 3,9KHz (Timer2)

 * PWM1 sur RC2 (TMR2)=0% 
 * PWM2 sur RC1 (TMR2)=0% 
 Init INA226 mesure de courant via I2C, shunt de 150mV pou 15Amps
 Config  INA226_CONF_REG,0x43FF (was 0x4127 )
 Calibration register 05h (pour shunt 0,01 ohm  et 8 Amps) 
 Mask/Alert  MASK_EN_REG register 06h <- 0x8001
 Alert MASK_EN_REG register 07h <- 2400 pour 0.6 A
 Mesure de courant     0 mA 
 Seuil d'alerte 0.600 Amperes
 INA Manufactuer  0x5449
 INA Identifiant 0x2260
 Fin de parametrage INA226... OK

 Test differentes valeurs de Duty-cycle via le clavier terminal YAT 
 Activer la sortie PWMy avec MA=1    (arret via MA=0)
 Entrer une valeur PWMy=xxxx puis <enter> avec y=1 ou 2 au clavier
Nb=    0  PWM1=    0        PWM2=    0  15.66 V  0.002 A . 0.023 W  Seuil=0.600  
Nb=    1  PWM1=    0        PWM2=    0  15.66 V  0.001 A . 0.020 W  Seuil=0.600  
Nb=    2  PWM1=    0        PWM2=    0  15.66 V  0.001 A . 0.020 W  Seuil=0.600  
Nb=    3  PWM1=    0        PWM2=    0  15.66 V  0.001 A . 0.020 W  Seuil=0.600  
Nb=    4  PWM1=    0        PWM2=    0  15.66 V  0.001 A . 0.020 W  Seuil=0.600  
Nb=    5  PWM1=    0        PWM2=    0  15.66 V  0.001 A . 0.020 W  Seuil=0.600  
MA=1
Nb=    6  PWM1=    0        PWM2=    0  15.66 V  0.001 A . 0.020 W  Seuil=0.600  
Nb=    7  PWM1=    0        PWM2=    0  15.66 V  0.001 A . 0.020 W  Seuil=0.600  
PWM1=0250
Recu :PWM1=0250
 Saisie OK PWM1-RC2  250 24.5%
Nb=    8  PWM1=  250        PWM2=    0  15.66 V  0.001 A . 0.020 W  Seuil=0.600  
Nb=    9  PWM1=  250        PWM2=    0  15.66 V  0.001 A . 0.020 W  Seuil=0.600  
Nb=   10  PWM1=  250        PWM2=    0  15.66 V  0.001 A . 0.020 W  Seuil=0.600  
Nb=   11  PWM1=  250        PWM2=    0  15.66 V  0.001 A . 0.020 W  Seuil=0.600  
PWM1=0000
Recu :PWM1=0000
 Saisie OK PWM1-RC2    0 0.0%
PWM1=0250
Recu :PWM1=0250
 Saisie OK PWM1-RC2  250 24.5%
PWM1=0250
Recu :PWM1=0250
 Saisie OK PWM1-RC2  250 24.5%
Nb=   12  PWM1=  250        PWM2=    0  15.66 V  0.001 A . 0.020 W  Seuil=0.600  
MA=1
Recu :MA=1
 ITB2 Enabled 
Nb=   13  PWM1=  250        PWM2=    0  15.64 V  0.025 A . 0.391 W  Seuil=0.600  
Nb=   14  PWM1=  250        PWM2=    0  15.64 V  0.025 A . 0.395 W  Seuil=0.600  
Nb=   15  PWM1=  250        PWM2=    0  15.58 V  0.071 A . 1.098 W  Seuil=0.600  
Nb=   16  PWM1=  250        PWM2=    0  15.56 V  0.082 A . 1.280 W  Seuil=0.600  
Nb=   17  PWM1=  250        PWM2=    0  15.53 V  0.101 A . 1.561 W  Seuil=0.600  
Nb=   18  PWM1=  250        PWM2=    0  15.53 V  0.100 A . 1.557 W  Seuil=0.600  
Nb=   19  PWM1=  250        PWM2=    0  15.54 V  0.093 A . 1.449 W  Seuil=0.600  
PWM1=0750
Recu :PWM1=0750
 Saisie OK PWM1-RC2  750 73.5%
Nb=   20  PWM1=  750        PWM2=    0
 Alarm Over_current ..faire un reset
  11.76 V  0.474 A A 5.576 W  Seuil=0.600  
Nb=   21  PWM1=    0        PWM2=    0  15.66 V  0.002 A . 0.023 W  Seuil=0.600  
Nb=   22  PWM1=    0        PWM2=    0  15.66 V  0.001 A . 0.020 W  Seuil=0.600  
Nb=   23  PWM1=    0        PWM2=    0  15.66 V  0.001 A . 0.020 W  Seuil=0.600  * 
 * 
 * 
 * 
 TEST ALERT (en mode pooling) !
via lecture registre INA
et blocage progressif de l'arbre moteur et augmentation PWM

Nb= 13 PWM1= 250 PWM2= 0 15.64 V 0.025 A . 0.391 W Seuil=0.600 
Nb= 14 PWM1= 250 PWM2= 0 15.64 V 0.025 A . 0.395 W Seuil=0.600 
Nb= 15 PWM1= 250 PWM2= 0 15.58 V 0.071 A . 1.098 W Seuil=0.600 
Nb= 16 PWM1= 250 PWM2= 0 15.56 V 0.082 A . 1.280 W Seuil=0.600 
Nb= 17 PWM1= 250 PWM2= 0 15.53 V 0.101 A . 1.561 W Seuil=0.600 
Nb= 18 PWM1= 250 PWM2= 0 15.53 V 0.100 A . 1.557 W Seuil=0.600 
Nb= 19 PWM1= 250 PWM2= 0 15.54 V 0.093 A . 1.449 W Seuil=0.600 
PWM1=0750
Recu :PWM1=0750
Saisie OK PWM1-RC2 750 73.5%
Nb= 20 PWM1= 750 PWM2= 0
Alarm Over_current ..faire un reset ou Restart
11.76 V 0.474 A A 5.576 W Seuil=0.600 
Nb= 21 PWM1= 0 PWM2= 0 15.66 V 0.002 A . 0.023 W Seuil=0.600 
moteur  l'arret suite ALERT. 
 * 
 * 
 * 
 * 
 * 
 * 
*/
